.\"
.\"Copyright (c) 2022 Sean Davies <skd@skd.id.au>
.\"
.\"Permission to use, copy, modify, and distribute this software for any
.\"purpose with or without fee is hereby granted, provided that the above
.\"copyright notice and this permission notice appear in all copies.
.\"
.\"THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\"WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\"MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\"ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\"WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\"ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\"OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.Dd $Mdocdate: December 8 2022 $
.Dt SMTPD-FAILURES 8
.Os
.Sh NAME
.Nm smtpd-failures
.Nd add failed smtpd authentication attempts to a pf table
.Sh SYNOPSIS
.Nm
.Op Fl d | m Ar max
.Op Fl m Ar file
.Sh DESCRIPTION
.Nm
is a utility that will add failed
.Xr smtpd 8
authentication attempts to a
.Xr pf 4
table.
.Pp
When run without any options the default
.Xr smtpd 8
log file will be checked for failed authentication attempts and once there has
been more than 10 from the same IP address, the IP address will be added to a
.Xr pf 4
table called
.Em smtpd_failures .
.Pp
Alternatively, the total count of each IP address and username that failed
authentication can be printed to stdout.
.Pp
The options are as follows:
.Bl -tag -width "XXXXXXXX"
.It Fl d
Debug mode.
Print failed authentication information and exit.
.It Fl f Ar file
Use an alternative maillog file.
.It Fl m Ar max
Set maximum authentication failures to add to the
.Xr pf 4
table.
.El
.Sh FILES
.Bl -tag -width "/var/log/maillog" -compact
.It Pa /var/log/maillog
Default
.Xr smtpd 8
maillog file.
.El
.Sh EXIT STATUS
.Ex -std
.Sh EXAMPLES
The following lines when added to
.Xr pf.conf 5
create an empty
.Xr pf 4
table and define a filter rule to block all traffic
coming from addresses listed in the
.Xr pf 4
table.
.Bd -literal -offset indent
table <smtpd_failures> persist
block drop quick on egress from <smtpd_failures> to any
.Ed
.Pp
.Nm
is then run from
.Xr crontab 5
every 5 minutes to add addresses which have reached the failed authentication
limit of 5 to the
.Xr pf 4
table.
.Bd -literal -offset indent
*/5 * * * * /usr/local/bin/smtpd-failures -m 5
.Ed
.Sh SEE ALSO
.Xr pf 4 ,
.Xr crontab 5 ,
.Xr pf.conf 5 ,
.Xr cron 8 ,
.Xr pfctl 8 ,
.Xr smtpd 8
.Sh AUTHORS
.An Sean Davies Aq Mt skd@skd.id.au
.Sh CAVEATS
.Nm
only takes into account the number of failed authentications within the log
file, not when the log file is rotated or time between authenticaiton attempts.
Additionally the IP addresses added to the
.Xr pf 4
table are not persistent across
reboots.
